#include <boost/thread.hpp>
#include <iostream>
#include <boost/thread/mutex.hpp>


boost::mutex io_mutex;

unsigned int max_num = 100;


// Create a specific thread function

void thread_function(unsigned int i){

  // data specific for this thread
  boost::thread_specific_ptr<unsigned int> j_ptr;   
  j_ptr.reset(new unsigned int(i));
  //

  // do some work
  for (; *j_ptr < max_num; (*j_ptr)++){

    // get the lock for output
    boost::mutex::scoped_lock lock(io_mutex);
    std::cout << "num=" << i << " id=" << boost::this_thread::get_id()
	      << " -> " << *j_ptr << std::endl;

    // here we are out of scope, so lock is relesed
  }
}

int main(){

  boost::thread_group tg;

  for (unsigned int num = 0 ; num < max_num ; num++){
    std::cout << "Starting thread : " << num << std::endl;
    boost::thread * t_ptr = new boost::thread(thread_function, num);
    tg.add_thread(t_ptr);
  }

  // wait all the threads conclusion
  tg.join_all();
}
